/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"time"
)

// checks if the MysqlUserAuth type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MysqlUserAuth{}

// MysqlUserAuth struct for MysqlUserAuth
type MysqlUserAuth struct {
	Id           NullableInt32               `json:"id,omitempty"`
	CustomerId   *string                     `json:"customer_id,omitempty"`
	CreatedAt    NullableInt32               `json:"created_at,omitempty"`
	UpdatedAt    NullableInt32               `json:"updated_at,omitempty"`
	Label        *string                     `json:"label,omitempty"`
	ObjectId     *string                     `json:"objectId,omitempty"`
	Status       *bool                       `json:"status,omitempty"`
	StatusDetail *string                     `json:"status_detail,omitempty"`
	ServiceType  *string                     `json:"service_type,omitempty"`
	LastUse      NullableTime                `json:"last_use,omitempty"`
	Identifier   *string                     `json:"identifier,omitempty"`
	Hash         *string                     `json:"hash,omitempty"`
	Type         *string                     `json:"type,omitempty"`
	Dsn          *string                     `json:"dsn,omitempty"`
	Host         *string                     `json:"host,omitempty"`
	Port         *int32                      `json:"port,omitempty"`
	Username     *string                     `json:"username,omitempty"`
	Password     *string                     `json:"password,omitempty"`
	Database     *string                     `json:"database,omitempty"`
	SshConfig    NullableMysqlTraitSshConfig `json:"sshConfig,omitempty"`
	Ssl          NullableString              `json:"ssl,omitempty"`
	Tls          *string                     `json:"tls,omitempty"`
}

// NewMysqlUserAuth instantiates a new MysqlUserAuth object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMysqlUserAuth() *MysqlUserAuth {
	this := MysqlUserAuth{}
	return &this
}

// NewMysqlUserAuthWithDefaults instantiates a new MysqlUserAuth object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMysqlUserAuthWithDefaults() *MysqlUserAuth {
	this := MysqlUserAuth{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlUserAuth) GetId() int32 {
	if o == nil || IsNil(o.Id.Get()) {
		var ret int32
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlUserAuth) GetIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableInt32 and assigns it to the Id field.
func (o *MysqlUserAuth) SetId(v int32) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *MysqlUserAuth) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *MysqlUserAuth) UnsetId() {
	o.Id.Unset()
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *MysqlUserAuth) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlUserAuth) GetCreatedAt() int32 {
	if o == nil || IsNil(o.CreatedAt.Get()) {
		var ret int32
		return ret
	}
	return *o.CreatedAt.Get()
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlUserAuth) GetCreatedAtOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.CreatedAt.Get(), o.CreatedAt.IsSet()
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasCreatedAt() bool {
	if o != nil && o.CreatedAt.IsSet() {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given NullableInt32 and assigns it to the CreatedAt field.
func (o *MysqlUserAuth) SetCreatedAt(v int32) {
	o.CreatedAt.Set(&v)
}

// SetCreatedAtNil sets the value for CreatedAt to be an explicit nil
func (o *MysqlUserAuth) SetCreatedAtNil() {
	o.CreatedAt.Set(nil)
}

// UnsetCreatedAt ensures that no value is present for CreatedAt, not even an explicit nil
func (o *MysqlUserAuth) UnsetCreatedAt() {
	o.CreatedAt.Unset()
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlUserAuth) GetUpdatedAt() int32 {
	if o == nil || IsNil(o.UpdatedAt.Get()) {
		var ret int32
		return ret
	}
	return *o.UpdatedAt.Get()
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlUserAuth) GetUpdatedAtOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.UpdatedAt.Get(), o.UpdatedAt.IsSet()
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasUpdatedAt() bool {
	if o != nil && o.UpdatedAt.IsSet() {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given NullableInt32 and assigns it to the UpdatedAt field.
func (o *MysqlUserAuth) SetUpdatedAt(v int32) {
	o.UpdatedAt.Set(&v)
}

// SetUpdatedAtNil sets the value for UpdatedAt to be an explicit nil
func (o *MysqlUserAuth) SetUpdatedAtNil() {
	o.UpdatedAt.Set(nil)
}

// UnsetUpdatedAt ensures that no value is present for UpdatedAt, not even an explicit nil
func (o *MysqlUserAuth) UnsetUpdatedAt() {
	o.UpdatedAt.Unset()
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *MysqlUserAuth) SetLabel(v string) {
	o.Label = &v
}

// GetObjectId returns the ObjectId field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetObjectId() string {
	if o == nil || IsNil(o.ObjectId) {
		var ret string
		return ret
	}
	return *o.ObjectId
}

// GetObjectIdOk returns a tuple with the ObjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetObjectIdOk() (*string, bool) {
	if o == nil || IsNil(o.ObjectId) {
		return nil, false
	}
	return o.ObjectId, true
}

// HasObjectId returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasObjectId() bool {
	if o != nil && !IsNil(o.ObjectId) {
		return true
	}

	return false
}

// SetObjectId gets a reference to the given string and assigns it to the ObjectId field.
func (o *MysqlUserAuth) SetObjectId(v string) {
	o.ObjectId = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetStatus() bool {
	if o == nil || IsNil(o.Status) {
		var ret bool
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetStatusOk() (*bool, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given bool and assigns it to the Status field.
func (o *MysqlUserAuth) SetStatus(v bool) {
	o.Status = &v
}

// GetStatusDetail returns the StatusDetail field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetStatusDetail() string {
	if o == nil || IsNil(o.StatusDetail) {
		var ret string
		return ret
	}
	return *o.StatusDetail
}

// GetStatusDetailOk returns a tuple with the StatusDetail field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetStatusDetailOk() (*string, bool) {
	if o == nil || IsNil(o.StatusDetail) {
		return nil, false
	}
	return o.StatusDetail, true
}

// HasStatusDetail returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasStatusDetail() bool {
	if o != nil && !IsNil(o.StatusDetail) {
		return true
	}

	return false
}

// SetStatusDetail gets a reference to the given string and assigns it to the StatusDetail field.
func (o *MysqlUserAuth) SetStatusDetail(v string) {
	o.StatusDetail = &v
}

// GetServiceType returns the ServiceType field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetServiceType() string {
	if o == nil || IsNil(o.ServiceType) {
		var ret string
		return ret
	}
	return *o.ServiceType
}

// GetServiceTypeOk returns a tuple with the ServiceType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetServiceTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ServiceType) {
		return nil, false
	}
	return o.ServiceType, true
}

// HasServiceType returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasServiceType() bool {
	if o != nil && !IsNil(o.ServiceType) {
		return true
	}

	return false
}

// SetServiceType gets a reference to the given string and assigns it to the ServiceType field.
func (o *MysqlUserAuth) SetServiceType(v string) {
	o.ServiceType = &v
}

// GetLastUse returns the LastUse field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlUserAuth) GetLastUse() time.Time {
	if o == nil || IsNil(o.LastUse.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastUse.Get()
}

// GetLastUseOk returns a tuple with the LastUse field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlUserAuth) GetLastUseOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastUse.Get(), o.LastUse.IsSet()
}

// HasLastUse returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasLastUse() bool {
	if o != nil && o.LastUse.IsSet() {
		return true
	}

	return false
}

// SetLastUse gets a reference to the given NullableTime and assigns it to the LastUse field.
func (o *MysqlUserAuth) SetLastUse(v time.Time) {
	o.LastUse.Set(&v)
}

// SetLastUseNil sets the value for LastUse to be an explicit nil
func (o *MysqlUserAuth) SetLastUseNil() {
	o.LastUse.Set(nil)
}

// UnsetLastUse ensures that no value is present for LastUse, not even an explicit nil
func (o *MysqlUserAuth) UnsetLastUse() {
	o.LastUse.Unset()
}

// GetIdentifier returns the Identifier field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetIdentifier() string {
	if o == nil || IsNil(o.Identifier) {
		var ret string
		return ret
	}
	return *o.Identifier
}

// GetIdentifierOk returns a tuple with the Identifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetIdentifierOk() (*string, bool) {
	if o == nil || IsNil(o.Identifier) {
		return nil, false
	}
	return o.Identifier, true
}

// HasIdentifier returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasIdentifier() bool {
	if o != nil && !IsNil(o.Identifier) {
		return true
	}

	return false
}

// SetIdentifier gets a reference to the given string and assigns it to the Identifier field.
func (o *MysqlUserAuth) SetIdentifier(v string) {
	o.Identifier = &v
}

// GetHash returns the Hash field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetHash() string {
	if o == nil || IsNil(o.Hash) {
		var ret string
		return ret
	}
	return *o.Hash
}

// GetHashOk returns a tuple with the Hash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetHashOk() (*string, bool) {
	if o == nil || IsNil(o.Hash) {
		return nil, false
	}
	return o.Hash, true
}

// HasHash returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasHash() bool {
	if o != nil && !IsNil(o.Hash) {
		return true
	}

	return false
}

// SetHash gets a reference to the given string and assigns it to the Hash field.
func (o *MysqlUserAuth) SetHash(v string) {
	o.Hash = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MysqlUserAuth) SetType(v string) {
	o.Type = &v
}

// GetDsn returns the Dsn field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetDsn() string {
	if o == nil || IsNil(o.Dsn) {
		var ret string
		return ret
	}
	return *o.Dsn
}

// GetDsnOk returns a tuple with the Dsn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetDsnOk() (*string, bool) {
	if o == nil || IsNil(o.Dsn) {
		return nil, false
	}
	return o.Dsn, true
}

// HasDsn returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasDsn() bool {
	if o != nil && !IsNil(o.Dsn) {
		return true
	}

	return false
}

// SetDsn gets a reference to the given string and assigns it to the Dsn field.
func (o *MysqlUserAuth) SetDsn(v string) {
	o.Dsn = &v
}

// GetHost returns the Host field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetHost() string {
	if o == nil || IsNil(o.Host) {
		var ret string
		return ret
	}
	return *o.Host
}

// GetHostOk returns a tuple with the Host field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetHostOk() (*string, bool) {
	if o == nil || IsNil(o.Host) {
		return nil, false
	}
	return o.Host, true
}

// HasHost returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasHost() bool {
	if o != nil && !IsNil(o.Host) {
		return true
	}

	return false
}

// SetHost gets a reference to the given string and assigns it to the Host field.
func (o *MysqlUserAuth) SetHost(v string) {
	o.Host = &v
}

// GetPort returns the Port field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetPort() int32 {
	if o == nil || IsNil(o.Port) {
		var ret int32
		return ret
	}
	return *o.Port
}

// GetPortOk returns a tuple with the Port field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetPortOk() (*int32, bool) {
	if o == nil || IsNil(o.Port) {
		return nil, false
	}
	return o.Port, true
}

// HasPort returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasPort() bool {
	if o != nil && !IsNil(o.Port) {
		return true
	}

	return false
}

// SetPort gets a reference to the given int32 and assigns it to the Port field.
func (o *MysqlUserAuth) SetPort(v int32) {
	o.Port = &v
}

// GetUsername returns the Username field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetUsername() string {
	if o == nil || IsNil(o.Username) {
		var ret string
		return ret
	}
	return *o.Username
}

// GetUsernameOk returns a tuple with the Username field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetUsernameOk() (*string, bool) {
	if o == nil || IsNil(o.Username) {
		return nil, false
	}
	return o.Username, true
}

// HasUsername returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasUsername() bool {
	if o != nil && !IsNil(o.Username) {
		return true
	}

	return false
}

// SetUsername gets a reference to the given string and assigns it to the Username field.
func (o *MysqlUserAuth) SetUsername(v string) {
	o.Username = &v
}

// GetPassword returns the Password field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetPassword() string {
	if o == nil || IsNil(o.Password) {
		var ret string
		return ret
	}
	return *o.Password
}

// GetPasswordOk returns a tuple with the Password field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetPasswordOk() (*string, bool) {
	if o == nil || IsNil(o.Password) {
		return nil, false
	}
	return o.Password, true
}

// HasPassword returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasPassword() bool {
	if o != nil && !IsNil(o.Password) {
		return true
	}

	return false
}

// SetPassword gets a reference to the given string and assigns it to the Password field.
func (o *MysqlUserAuth) SetPassword(v string) {
	o.Password = &v
}

// GetDatabase returns the Database field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetDatabase() string {
	if o == nil || IsNil(o.Database) {
		var ret string
		return ret
	}
	return *o.Database
}

// GetDatabaseOk returns a tuple with the Database field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetDatabaseOk() (*string, bool) {
	if o == nil || IsNil(o.Database) {
		return nil, false
	}
	return o.Database, true
}

// HasDatabase returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasDatabase() bool {
	if o != nil && !IsNil(o.Database) {
		return true
	}

	return false
}

// SetDatabase gets a reference to the given string and assigns it to the Database field.
func (o *MysqlUserAuth) SetDatabase(v string) {
	o.Database = &v
}

// GetSshConfig returns the SshConfig field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlUserAuth) GetSshConfig() MysqlTraitSshConfig {
	if o == nil || IsNil(o.SshConfig.Get()) {
		var ret MysqlTraitSshConfig
		return ret
	}
	return *o.SshConfig.Get()
}

// GetSshConfigOk returns a tuple with the SshConfig field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlUserAuth) GetSshConfigOk() (*MysqlTraitSshConfig, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshConfig.Get(), o.SshConfig.IsSet()
}

// HasSshConfig returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasSshConfig() bool {
	if o != nil && o.SshConfig.IsSet() {
		return true
	}

	return false
}

// SetSshConfig gets a reference to the given NullableMysqlTraitSshConfig and assigns it to the SshConfig field.
func (o *MysqlUserAuth) SetSshConfig(v MysqlTraitSshConfig) {
	o.SshConfig.Set(&v)
}

// SetSshConfigNil sets the value for SshConfig to be an explicit nil
func (o *MysqlUserAuth) SetSshConfigNil() {
	o.SshConfig.Set(nil)
}

// UnsetSshConfig ensures that no value is present for SshConfig, not even an explicit nil
func (o *MysqlUserAuth) UnsetSshConfig() {
	o.SshConfig.Unset()
}

// GetSsl returns the Ssl field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlUserAuth) GetSsl() string {
	if o == nil || IsNil(o.Ssl.Get()) {
		var ret string
		return ret
	}
	return *o.Ssl.Get()
}

// GetSslOk returns a tuple with the Ssl field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlUserAuth) GetSslOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Ssl.Get(), o.Ssl.IsSet()
}

// HasSsl returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasSsl() bool {
	if o != nil && o.Ssl.IsSet() {
		return true
	}

	return false
}

// SetSsl gets a reference to the given NullableString and assigns it to the Ssl field.
func (o *MysqlUserAuth) SetSsl(v string) {
	o.Ssl.Set(&v)
}

// SetSslNil sets the value for Ssl to be an explicit nil
func (o *MysqlUserAuth) SetSslNil() {
	o.Ssl.Set(nil)
}

// UnsetSsl ensures that no value is present for Ssl, not even an explicit nil
func (o *MysqlUserAuth) UnsetSsl() {
	o.Ssl.Unset()
}

// GetTls returns the Tls field value if set, zero value otherwise.
func (o *MysqlUserAuth) GetTls() string {
	if o == nil || IsNil(o.Tls) {
		var ret string
		return ret
	}
	return *o.Tls
}

// GetTlsOk returns a tuple with the Tls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlUserAuth) GetTlsOk() (*string, bool) {
	if o == nil || IsNil(o.Tls) {
		return nil, false
	}
	return o.Tls, true
}

// HasTls returns a boolean if a field has been set.
func (o *MysqlUserAuth) HasTls() bool {
	if o != nil && !IsNil(o.Tls) {
		return true
	}

	return false
}

// SetTls gets a reference to the given string and assigns it to the Tls field.
func (o *MysqlUserAuth) SetTls(v string) {
	o.Tls = &v
}

func (o MysqlUserAuth) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MysqlUserAuth) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customer_id"] = o.CustomerId
	}
	if o.CreatedAt.IsSet() {
		toSerialize["created_at"] = o.CreatedAt.Get()
	}
	if o.UpdatedAt.IsSet() {
		toSerialize["updated_at"] = o.UpdatedAt.Get()
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ObjectId) {
		toSerialize["objectId"] = o.ObjectId
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.StatusDetail) {
		toSerialize["status_detail"] = o.StatusDetail
	}
	if !IsNil(o.ServiceType) {
		toSerialize["service_type"] = o.ServiceType
	}
	if o.LastUse.IsSet() {
		toSerialize["last_use"] = o.LastUse.Get()
	}
	if !IsNil(o.Identifier) {
		toSerialize["identifier"] = o.Identifier
	}
	if !IsNil(o.Hash) {
		toSerialize["hash"] = o.Hash
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Dsn) {
		toSerialize["dsn"] = o.Dsn
	}
	if !IsNil(o.Host) {
		toSerialize["host"] = o.Host
	}
	if !IsNil(o.Port) {
		toSerialize["port"] = o.Port
	}
	if !IsNil(o.Username) {
		toSerialize["username"] = o.Username
	}
	if !IsNil(o.Password) {
		toSerialize["password"] = o.Password
	}
	if !IsNil(o.Database) {
		toSerialize["database"] = o.Database
	}
	if o.SshConfig.IsSet() {
		toSerialize["sshConfig"] = o.SshConfig.Get()
	}
	if o.Ssl.IsSet() {
		toSerialize["ssl"] = o.Ssl.Get()
	}
	if !IsNil(o.Tls) {
		toSerialize["tls"] = o.Tls
	}
	return toSerialize, nil
}

type NullableMysqlUserAuth struct {
	value *MysqlUserAuth
	isSet bool
}

func (v NullableMysqlUserAuth) Get() *MysqlUserAuth {
	return v.value
}

func (v *NullableMysqlUserAuth) Set(val *MysqlUserAuth) {
	v.value = val
	v.isSet = true
}

func (v NullableMysqlUserAuth) IsSet() bool {
	return v.isSet
}

func (v *NullableMysqlUserAuth) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMysqlUserAuth(val *MysqlUserAuth) *NullableMysqlUserAuth {
	return &NullableMysqlUserAuth{value: val, isSet: true}
}

func (v NullableMysqlUserAuth) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMysqlUserAuth) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
